#include "condition.hpp"
#include <iostream>
#include <thread>
#include <unistd.h>

using namespace std;

struct TwoWait {
   TwoWait(ConditionPtr a, ConditionPtr b,
      const std::string& text) : conda(a), condb(b), msg(text) {
   }
   void operator()() {
      cout << "waiting for " << msg << endl;
      ConditionSetPtr cset(new ConditionSet);
      cset->include(conda);
      cset->include(condb);
      std::mutex mutex;
      std::unique_lock<std::mutex> lock(mutex);
      cset->wait(lock);
      cout << "returned from wait for " << msg << endl;
   }
   ConditionPtr conda;
   ConditionPtr condb;
   std::string msg;
};

int main() {
   ConditionPtr a(new Condition());
   ConditionPtr b(new Condition());
   ConditionPtr c(new Condition());
   std::thread t1(TwoWait(a, b, "a or b"));
   std::thread t2(TwoWait(b, c, "b or c"));
   std::thread t3(TwoWait(a, c, "a or c"));
   sleep(1);
   cout << "all threads started" << endl;
   cout << "signaling b: " << endl; b->notify_all(); sleep(1);
   cout << "signaling c: " << endl; c->notify_all(); sleep(1);
   t1.join(); t2.join(); t3.join();
}
